module ParserBackEnd
  include ParserCommon

  require 'nokogiri'

      # c.define_tag 'language_bar' do
      #   @site.in_use_locales.map{ |locale|
      #     lang = I18nVariable.first(:conditions => {:key => locale})[locale]
      #     if I18n.locale.to_s.eql?(locale)
      #       lang
      #     else
      #       "<a href='?locale=#{locale}'>#{lang}</a>"
      #     end
      #   }.join(' | ')
      # end
      # c.define_tag 'link' do |tag|
      #   item = Item.first(:conditions => { :full_name => tag.attr['name'] })
      #   ret = ''
      #   ret << "<a href='"
      #   ret << eval("admin_#{item._type.downcase}_path(item.id)")
      #   ret << "' class='nav'>"
      #   ret << item.i18n_variable[I18n.locale]
      #   ret << "</a>"
      # end

  def parse_page_edit_noko(page, id = nil)
    body = Nokogiri::HTML(page.design.layout.body)
    parse_menu(body, page, true)
    public_r_tags = parse_content_edits(body, page, id)
    parse_images(body, page)
    parse_footer(body, page, true)

    public_r_tags.each do |tag|
      send("parse_#{tag}s", body, page,id)
    end

    body.to_html
  end

  # page_contents
  def parse_content_edits(body, page, id)
    public_r_tags = []
    body.css('.page_content').each do |content|
      ret = ''
      if (content["main"] == "true" && !page.module_app.nil?)
        ret << "<div id='appfrontend' class='dymanic_load' path='/panel/#{page.module_app.key}/front_end/#{page.app_frontend_url}?inner=true&page_id=#{page.id}"
        ret << "&category_id=#{page.category}" if page[:category]
        ret << "'></div>"
      else
        part = page.page_parts.detect{ |p| p.name.to_s == content['name'].to_s } rescue nil
        ret << "<div id='#{content['name']}' part_id='#{part.id}' class='editable' style='border:solid 1px; margin:5px; padding:5px;'>" if part
        ret << "<div class='edit_link' style='display:none'>"
        ret << " <a href='#{edit_admin_page_part_path(part.id)}' class='nav'>#{t(:edit)}</a>" if part
        ret << '</div>'
        case part.kind
        when 'text'
          ret << part.i18n_variable[I18n.locale] rescue ''
        when 'module_widget'
          if part[:category]
            ret << "<div class='dymanic_load' path='/panel/#{part.module_app.key}/widget/#{part.widget_path}?category_id=#{part[:category]}'></div>"
          else
            ret << "<div class='dymanic_load' path='/panel/#{part.module_app.key}/widget/#{part.widget_path}'></div>"
          end
        when 'public_r_tag'
          ret << "<r:#{part.public_r_tag} id='#{part.public_r_tag_object_id}'/>"
          public_r_tags << part.public_r_tag
        else
            ''
        end if part
      end
      scope = "<#{content.name}"
      content.attributes.each_pair do |key, value|
        scope << " #{key}='#{value}'"
      end
      scope << ">#{ret}</#{content.name}>"
      fragment = Nokogiri::HTML::DocumentFragment.new(body, scope)
      content.swap(fragment)
    end
    public_r_tags.uniq
  end


  def self.included(base)
    base.send :helper_method, :parse_page_edit_noko if base.respond_to? :helper_method
  end

end
